Index: trunk/kernel/fs/fatfs/fatfs.c
===================================================================
--- trunk/kernel/fs/fatfs/fatfs.c	(revision 1)
+++ trunk/kernel/fs/fatfs/fatfs.c	(revision 1)
@@ -0,0 +1,142 @@
+/*
+ * fatfs.c - FATFS file system API implementation.
+ *
+ * Author    Mohamed Lamine Karaoui (2015)
+ *           Alain Greiner (2016)
+ *
+ * Copyright (c) UPMC Sorbonne Universites
+ *
+ * This file is part of ALMOS-MKH.
+ *
+ * ALMOS-MKH is free software; you can redistribute it and/or modify it
+ * under the terms of the GNU General Public License as published by
+ * the Free Software Foundation; version 2.0 of the License.
+ *
+ * ALMOS-MKH is distributed in the hope that it will be useful, but
+ * WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
+ * General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with ALMOS-MKH; if not, write to the Free Software Foundation,
+ * Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA
+ */
+
+
+#include <hal_types.h>
+#include <hal_special.h>
+#include <printk.h>
+#include <kmem.h>
+#include <vfs.h>
+#include <fatfs.h>
+
+
+///////////////////////////////////////////////////////////////////////////////////////
+// FATFS specific functions : these static functions cannot be directly
+//                            called by the VFS 
+///////////////////////////////////////////////////////////////////////////////////////
+
+
+
+
+///////////////////////////////////////////////////////////////////////////////////////
+// Generic API : the following functions are called by the VFS, 
+//               and must be defined by all supported file systems.
+///////////////////////////////////////////////////////////////////////////////////////
+
+////////////////////////////////////////////////////////////
+error_t fatfs_inode_create( struct vfs_inode_s * vfs_inode )
+{
+    printk("\n[PANIC] %s not fully implemented yet\n", __FUNCTION__ );
+    hal_core_sleep();
+
+    kmem_req_t      req;
+    error_t         error;
+    fatfs_inode_t * fatfs_inode;
+    uint32_t        cluster;        // allocated cluster index
+
+    // allocate memory for fatfs inode
+	req.type    = KMEM_FATFS_INODE;
+	req.size    = sizeof(fatfs_inode_t);
+    req.flags   = AF_KERNEL | AF_ZERO;
+	fatfs_inode = (fatfs_inode_t *)kmem_alloc( &req );
+
+    if( fatfs_inode == NULL ) return ENOMEM;
+
+    // initialise ramfs_inode 
+    fatfs_inode->first_cluster = 0;   // TODO ???
+    fatfs_inode->ctx           = (fatfs_ctx_t *)vfs_inode->ctx->extend;
+ 
+    // link vfs_inode to ramfs_inode
+    inode->extend    = ramfs_inode;
+    ramfs->vfs_inode = vfs_inode;
+
+    return 0;
+
+}
+
+//////////////////////////////////////////////////////
+void fatfs_inode_destroy( struct vfs_inode_s * inode )
+{
+    printk("\n[PANIC] %s not fully implemented yet\n", __FUNCTION__ );
+    hal_core_sleep();
+}
+
+////////////////////////////////////////////////
+error_t fatfs_write_page( struct page_s * page )
+{
+    printk("\n[PANIC] %s not fully implemented yet\n", __FUNCTION__ );
+    hal_core_sleep();
+
+    // get pointer on mapper and page index from page descriptor
+    mapper_t * mapper = page->mapper;
+    uint32_t   index  = page->index;
+
+    if( mapper == NULL)
+    {
+        printk("\n[PANIC] in %s : no mapper for this page\n", __FUNCTION__ );
+        hal_core_sleep();
+    }
+
+    // get VFS inode pointer from mapper
+    vfs_inode_t * vfs_inode = mapper->inode;
+
+    // get FATFS inode pointer for VFS inode
+    fatfs_inode_t * fatfs_inode = (fatfs_inode_t)vfs_inode->extend;
+
+    // get FATFS context and first cluster from FATFS inode
+    fatfs_ctx_t * fatfs_ctx     = fatfs_inode->ctx;
+    uint32_t      first_cluster = fatfs_inode->first_cluster;
+
+
+}
+
+///////////////////////////////////////////////
+error_t fatfs_read_page( struct page_s * page )
+{
+    printk("\n[PANIC] %s not fully implemented yet\n", __FUNCTION__ );
+    hal_core_sleep();
+
+    // get pointer on mapper and page index from page descriptor
+    mapper_t * mapper = page->mapper;
+    uint32_t   index  = page->index;
+
+    if( mapper == NULL)
+    {
+        printk("\n[PANIC] in %s : no mapper for this page\n", __FUNCTION__ );
+        hal_core_sleep();
+    }
+
+    // get VFS inode pointer from mapper
+    vfs_inode_t * vfs_inode = mapper->inode;
+
+    // get FATFS inode pointer for VFS inode
+    fatfs_inode_t * fatfs_inode = (fatfs_inode_t)vfs_inode->extend;
+
+    // get FATFS context and first cluster from FATFS inode
+    fatfs_ctx_t * fatfs_ctx     = fatfs_inode->ctx;
+    uint32_t      first_cluster = fatfs_inode->first_cluster;
+
+
+}
+
Index: trunk/kernel/fs/fatfs/fatfs.h
===================================================================
--- trunk/kernel/fs/fatfs/fatfs.h	(revision 1)
+++ trunk/kernel/fs/fatfs/fatfs.h	(revision 1)
@@ -0,0 +1,143 @@
+/*
+ * fatfs.h - FATFS file system API definition.
+ *
+ * Author    Mohamed Lamine Karaoui (2015)
+ *           Alain Greiner (2016)
+ *
+ * Copyright (c) UPMC Sorbonne Universites
+ *
+ * This file is part of ALMOS-MKH.
+ *
+ * ALMOS-MKH is free software; you can redistribute it and/or modify it
+ * under the terms of the GNU General Public License as published by
+ * the Free Software Foundation; version 2.0 of the License.
+ *
+ * ALMOS-MKH is distributed in the hope that it will be useful, but
+ * WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
+ * General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with ALMOS-MKH; if not, write to the Free Software Foundation,
+ * Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA
+ */
+
+#ifndef _FATFS_H_
+#define _FATFS_H_
+
+#include <hal_types.h>
+#include <rwlock.h>
+
+/****  Forward declarations  ****/
+
+struct mapper_s;
+struct device_s;
+struct vfs_inode_s;
+struct page_s;
+
+/*****************************************************************************************
+ * This structure defines a FATFS context descriptor 
+ ****************************************************************************************/
+
+typedef struct fatfs_ctx_s
+{
+    xptr_t            dev_xp;                /*! extended pointer on remote IOC device  */ 
+    rwlock_t          lock;                  /*! TODO protect what ???                  */
+    uint32_t          fat_begin_lba;
+    uint32_t          fat_sectors_count;
+    uint32_t          bytes_per_sector;
+    uint32_t          bytes_per_cluster;
+    uint32_t          cluster_begin_lba;
+    uint32_t          sectors_per_cluster;
+    uint32_t          rootdir_first_cluster;
+    uint32_t          last_allocated_sector;
+    uint32_t          last_allocated_index;  /*! TODO last allocated cluster ???        */
+    struct mapper_s * mapper;                /*! mapper for the FAT itself              */ 
+}
+fatfs_ctx_t;
+
+/*****************************************************************************************
+ * This structure defines the FAT specific inode extension (versus the VFS inode).
+ ****************************************************************************************/
+
+typedef struct fatfs_inode_s
+{
+    struct fatfs_ctx_s * ctx;                /*! local pointer on the FATFS context     */ 
+	uint32_t             first_cluster;      /*! first cluster on device                */ 
+}
+fatfs_inode_t;
+
+/*****************************************************************************************
+ * This structure defines a FAT specific extension to the generic vfs_dentry_t.
+ * TODO a-ton vraiment besoin de cette structure [AG]
+ ****************************************************************************************/
+
+struct fat_dentry_s
+{
+	uint32_t          entry_index;           /*! TODO ???                               */  
+	uint32_t          first_cluster;         /*! TODO ???                               */
+}
+fat_dentry_t;
+
+
+
+
+
+/*****************************************************************************************
+ * This function allocates memory for a FATFS inode, initializes it,
+ * and link it to the VFS inode.
+ * TODO [AG] : faut-il rechercher le fichier correspondant sur le disque,
+ * ou faut-il allouer un nouveau cluster?
+ *****************************************************************************************
+ * @ inode   : local pointer on vfs_inode.
+ * @ return 0 if success / return ENOMEM if error. 
+ ****************************************************************************************/
+error_t fatfs_inode_create( struct vfs_inode_s * inode );
+
+/*****************************************************************************************
+ * This function releases memory allocated for a FATFS inode.
+ *****************************************************************************************
+ * @ inode   : local pointer on vfs_inode.
+ ****************************************************************************************/
+void fatfs_inode_destroy( struct vfs_inode_s * inode );
+
+/*****************************************************************************************
+ * This function allocates memory for a FATFS context, initialises it, 
+ * and link it to the local VFS context.
+ *****************************************************************************************
+ * @ inode   : local pointer on VFS context.
+ * @ return 0 if success / return ENOMEM if error. 
+ ****************************************************************************************/
+error_t fatfs_context_create( struct vfs_ctx_s * ctx );
+
+/*****************************************************************************************
+ * This function releases memory allocated for a FATFS context.
+ *****************************************************************************************
+ * @ ctx   : local pointer on VFS context.
+ ****************************************************************************************/
+void fatfs_inode_destroy( struct vfs_ctx_s * ctx );
+
+/*****************************************************************************************
+ * This function moves a page from the mapper to the FATFS file system.
+ * It must be called by a thread running in cluster containing the mapper.
+ * The pointer on the mapper and the page index in file are supposed to be registered
+ * in the page descriptor. 
+ *****************************************************************************************
+ * @ page    : local pointer on page descriptor.
+ * @ return 0 if success / return EIO if error. 
+ ****************************************************************************************/
+error_t fatfs_write_page( struct page_s * page );
+
+/*****************************************************************************************
+ * This function moves a page from the FATFS file system on device to the mapper.
+ * It must be called by a thread running in cluster containing the mapper.
+ * The pointer on the mapper and the page index in file are supposed to be registered
+ * in the page descriptor. 
+ *****************************************************************************************
+ * @ page    : local pointer on page descriptor.
+ * @ return 0 if success / return EIO if error. 
+ ****************************************************************************************/
+error_t fatfs_read_page( struct page_s * page );
+
+
+#endif	/* _FATFS_H_ */
Index: trunk/kernel/fs/fatfs/fatfs_private.h
===================================================================
--- trunk/kernel/fs/fatfs/fatfs_private.h	(revision 1)
+++ trunk/kernel/fs/fatfs/fatfs_private.h	(revision 1)
@@ -0,0 +1,159 @@
+/*
+ * fatfs_private.h - fat32 partition descriptors & helper functions
+ *
+ * Copyright (c) 2008,2009,2010,2011,2012 Ghassan Almaless
+ * Copyright (c) 2011,2012 UPMC Sorbonne Universites
+ *
+ * This file is part of ALMOS-kernel.
+ *
+ * ALMOS-kernel is free software; you can redistribute it and/or modify it
+ * under the terms of the GNU General Public License as published by
+ * the Free Software Foundation; version 2.0 of the License.
+ *
+ * ALMOS-kernel is distributed in the hope that it will be useful, but
+ * WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
+ * General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with ALMOS-kernel; if not, write to the Free Software Foundation,
+ * Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA
+ */
+
+#ifndef __VFAT_PRIVATE_H__
+#define __VFAT_PRIVATE_H__
+
+#include <stdint.h>
+#include <rwlock.h>
+
+#define VFAT_DEBUG      CONFIG_VFAT_DEBUG
+#define VFAT_INSTRUMENT CONFIG_VFAT_INSTRUMENT
+
+struct vfat_bpb_s
+{
+	uint8_t     BS_jmpBoot[3];
+	uint8_t     BS_OEMName[8];
+	uint16_t    BPB_BytsPerSec;
+	uint8_t	    BPB_SecPerClus;
+	uint16_t    BPB_RsvdSecCnt;
+	uint8_t	    BPB_NumFATs;
+	uint16_t    BPB_RootEntCnt;
+	uint16_t	BPB_TotSec16;
+	uint8_t	    BPB_Media;
+	uint16_t	BPB_FATSz16;
+	uint16_t	BPB_SecPerTrk;
+	uint16_t	BPB_NumHeads;
+	uint32_t	BPB_HiddSec;
+	uint32_t	BPB_TotSec32;
+	uint32_t	BPB_FATSz32;
+	uint16_t	BPB_ExtFlags;
+	uint16_t	BPB_VFVer;
+	uint32_t	BPB_RootClus;
+	uint16_t	BPB_FSInfo;
+	uint16_t	BPB_BkBootSec;
+	uint8_t	    BPB_Reserved[12];
+	uint8_t	    BS_DrvNum;
+	uint8_t     BS_Reserved1;
+	uint8_t	    BS_BootSig;
+	uint32_t    BS_VolID;
+	uint8_t     BS_VolLab[11];
+	uint8_t     BS_FilSysType[8];
+} __attribute__ ((packed));
+
+
+struct vfat_DirEntry_s
+{
+	uint8_t	    DIR_Name[11];
+	uint8_t	    DIR_Attr;
+	uint8_t	    DIR_NTRes;
+	uint8_t	    DIR_CrtTimeTenth;
+	uint16_t	DIR_CrtTime;
+	uint16_t	DIR_CrtDate;
+	uint16_t	DIR_LstAccTime;
+	uint16_t	DIR_FstClusHI;
+	uint16_t	DIR_WrtTime;
+	uint16_t	DIR_WrtDate;
+	uint16_t	DIR_FstClusLO;
+	uint32_t	DIR_FileSize;
+} __attribute__ ((packed));
+
+
+#define VFAT_ATTR_READ_ONLY	0x01
+#define VFAT_ATTR_HIDDEN	0x02
+#define VFAT_ATTR_SYSTEM	0x04
+#define VFAT_ATTR_VOLUME_ID	0x08
+#define VFAT_ATTR_DIRECTORY	0x10
+#define VFAT_ATTR_ARCHIVE	0x20
+#define VFAT_ATTR_LONG_NAME	0x0F
+
+
+struct device_s;
+struct rwlock_s;
+
+
+struct vfat_inode_s
+{
+	uint32_t flags;
+	vfat_cluster_t first_cluster;
+};
+
+struct vfat_entry_request_s
+{
+	struct vfat_DirEntry_s *entry;
+	struct vfat_context_s *ctx;
+	struct vfs_inode_s *parent;
+	char *entry_name;
+	uint_t *entry_index;
+};
+
+extern const struct vfs_inode_op_s vfat_i_op;
+extern const struct vfs_dirent_op_s vfat_d_op;
+extern const struct vfs_file_op_s vfat_f_op;
+extern const struct mapper_op_s vfat_file_mapper_op;
+extern const struct mapper_op_s vfat_inode_mapper_op;
+
+
+/**
+ * Gives the LBA of the first sector of a vfat cluster.
+ *
+ * @ctx		vfat_context
+ * @cluster	cluster to be converted
+ */
+#define VFAT_CONVERT_CLUSTER(ctx,cluster) (ctx)->cluster_begin_lba +	\
+					       ((cluster) - 2) * (ctx)->sectors_per_cluster
+
+int vfat_cluster_count(struct vfat_context_s *ctx, vfat_cluster_t cluster_index);
+
+error_t vfat_query_fat(struct vfat_context_s* ctx,
+		       vfat_cluster_t cluster_index,
+		       vfat_cluster_t *next_cluster_index);
+
+error_t vfat_alloc_fat_entry(struct vfat_context_s* ctx,
+			     vfat_cluster_t *new_cluster);
+
+error_t vfat_extend_cluster(struct vfat_context_s* ctx,
+			    vfat_cluster_t current_vfat_cluster,
+			    vfat_cluster_t *next_cluster);
+
+error_t vfat_free_fat_entry(struct vfat_context_s* ctx,
+			    vfat_cluster_t start_cluster);
+
+error_t vfat_locate_entry(struct vfat_entry_request_s *rq);
+
+inline void vfat_getshortname(char *from, char *to);
+
+error_t vfat_cluster_lookup(struct vfat_context_s* ctx,
+			    vfat_cluster_t node_cluster,
+			    vfat_cluster_t cluster_rank,
+			    vfat_cluster_t *cluster_index,
+			    uint_t *extended);
+
+
+#if VFAT_INSTRUMENT
+extern uint32_t blk_rd_count;
+extern uint32_t rd_count;
+extern uint32_t wr_count;
+#endif
+
+
+#endif
Index: trunk/kernel/fs/ramfs/ramfs.c
===================================================================
--- trunk/kernel/fs/ramfs/ramfs.c	(revision 1)
+++ trunk/kernel/fs/ramfs/ramfs.c	(revision 1)
@@ -0,0 +1,92 @@
+/*
+ * ramfs.c  RAMFS file system API implementation.
+ *
+ * Authors   Mohamed Lamine Karaoui (2015)
+ *           Alain Greiner (2016)
+ *
+ * Copyright (c) UPMC Sorbonne Universites
+ *
+ * This file is part of ALMOS-MKH.
+ *
+ * ALMOS-MKH is free software; you can redistribute it and/or modify it
+ * under the terms of the GNU General Public License as published by
+ * the Free Software Foundation; version 2.0 of the License.
+ *
+ * ALMOS-MKH is distributed in the hope that it will be useful, but
+ * WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
+ * General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with ALMOS-MKH; if not, write to the Free Software Foundation,
+ * Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA
+ */
+
+
+#include <hal_types.h>
+#include <hal_special.h>
+#include <printk.h>
+#include <kmem.h>
+#include <vfs.h>
+#include <ramfs.h>
+
+
+///////////////////////////////////////////////////////////////////////////////////////
+// RAMFS specific functions : these static functions cannot be called by the VFS 
+///////////////////////////////////////////////////////////////////////////////////////
+
+
+
+///////////////////////////////////////////////////////////////////////////////////////
+// Generic API : the following functions are called by the VFS, 
+//               and must be defined by all supported file systems.
+///////////////////////////////////////////////////////////////////////////////////////
+
+////////////////////////////////////////////////////////////
+error_t ramfs_inode_create( struct vfs_inode_s * vfs_inode )
+{
+    printk("\n[PANIC] %s not fully implemented yet\n", __FUNCTION__ );
+    hal_core_sleep();
+
+    kmem_req_t      req;
+    error_t         error;
+    ramfs_inode_t * ramfs_inode;
+
+    // allocate memory for ramfs inode
+	req.type    = KMEM_RAMFS_INODE;
+	req.size    = sizeof(ramfs_inode_t);
+    req.flags   = AF_KERNEL | AF_ZERO;
+	ramfs_inode = (ramfs_inode_t *)kmem_alloc( &req );
+
+    if( ramfs_inode == NULL ) return ENOMEM;
+
+    // initialise ramfs_inode TODO
+
+    // link vfs_inode to ramfs_inode
+    inode->extend    = ramfs_inode;
+    ramfs->vfs_inode = vfs_inode;
+
+    return 0;
+}
+
+//////////////////////////////////////////////////////
+void ramfs_inode_destroy( struct vfs_inode_s * inode )
+{
+    printk("\n[PANIC] %s not fully implemented yet\n", __FUNCTION__ );
+    hal_core_sleep();
+}
+
+/////////////////////////////////////////////////
+error_t ramfs_write_page( struct page_s  * page )
+{
+    printk("\n[PANIC] %s not fully implemented yet\n", __FUNCTION__ );
+    hal_core_sleep();
+}
+
+////////////////////////////////////////////////
+error_t ramfs_read_page( struct page_s  * page )
+{
+    printk("\n[PANIC] %s not fully implemented yet\n", __FUNCTION__ );
+    hal_core_sleep();
+}
+   
Index: trunk/kernel/fs/ramfs/ramfs.h
===================================================================
--- trunk/kernel/fs/ramfs/ramfs.h	(revision 1)
+++ trunk/kernel/fs/ramfs/ramfs.h	(revision 1)
@@ -0,0 +1,85 @@
+/*
+ * ramfs.h  RAMFS file system API definition.
+ *
+ * Authors   Mohamed Lamine Karaoui (2015)
+ *           Alain Greiner (2016)
+ *
+ * Copyright (c) UPMC Sorbonne Universites
+ *
+ * This file is part of ALMOS-MKH.
+ *
+ * ALMOS-MKH is free software; you can redistribute it and/or modify it
+ * under the terms of the GNU General Public License as published by
+ * the Free Software Foundation; version 2.0 of the License.
+ *
+ * ALMOS-MKH is distributed in the hope that it will be useful, but
+ * WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
+ * General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with ALMOS-MKH; if not, write to the Free Software Foundation,
+ * Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA
+ */
+
+#ifndef _RAMFS_H_
+#define _RAMFS_H_
+
+/****  Forward declarations  ****/
+
+struct vfs_inode_s;
+struct page_s;
+
+/*****************************************************************************************
+ * This structure defines the RAMFS inode specific extension (versus the VFS inode).
+ ****************************************************************************************/
+
+typedef struct ramfs_inode_s
+{
+    struct vfs_inode_s * vfs_inode;   /*! local pointer on VFS inode                    */
+}
+ramfs_inode_t;
+
+
+
+
+/*****************************************************************************************
+ * This function allocates memory for a RAMFS inode, and link it to the VFS inode.
+ *****************************************************************************************
+ * @ inode   : local pointer on vfs_inode.
+ * @ return 0 if success / return ENOMEM if error. 
+ ****************************************************************************************/
+error_t ramfs_inode_create( struct vfs_inode_s * inode );
+
+/*****************************************************************************************
+ * This function releases memory allocated for a RAMFS inode.
+ *****************************************************************************************
+ * @ inode   : local pointer on vfs_inode.
+ ****************************************************************************************/
+void ramfs_inode_destroy( struct vfs_inode_s * inode );
+
+/*****************************************************************************************
+ * This function moves a page from the mapper to the RAMFS file system.
+ * It must be called by a thread running in cluster containing the mapper.
+ * The pointer on the mapper and the page index in file are supposed to be registered
+ * in the page descriptor. 
+******************************************************************************************
+ * @ page    : local pointer on source page descriptor.
+ * @ return 0 if success / return EIO if error. 
+ ****************************************************************************************/
+error_t ramfs_write_page( struct page_s  * page );
+
+/*****************************************************************************************
+ * This function moves a page from the RAMFS file system to the mapper.
+ * It must be called by a thread running in cluster containing the mapper.
+ * The pointer on the mapper and the page index in file are supposed to be registered
+ * in the page descriptor. 
+ *****************************************************************************************
+ * @ page    : local pointer on destination page descriptor.
+ * @ return 0 if success / return EIO if error. 
+ ****************************************************************************************/
+error_t ramfs_read_page( struct page_s  * page );
+
+
+   
+#endif	/* _RAMFS_H_ */
Index: trunk/kernel/fs/sysfs/sysfs-private.h
===================================================================
--- trunk/kernel/fs/sysfs/sysfs-private.h	(revision 1)
+++ trunk/kernel/fs/sysfs/sysfs-private.h	(revision 1)
@@ -0,0 +1,48 @@
+/*
+ * sysfs/sysfs-private.h - sysfs internal functions and data types
+ *
+ * Copyright (c) 2008,2009,2010,2011,2012 Ghassan Almaless
+ * Copyright (c) 2011,2012 UPMC Sorbonne Universites
+ *
+ * This file is part of ALMOS-kernel.
+ *
+ * ALMOS-kernel is free software; you can redistribute it and/or modify it
+ * under the terms of the GNU General Public License as published by
+ * the Free Software Foundation; version 2.0 of the License.
+ *
+ * ALMOS-kernel is distributed in the hope that it will be useful, but
+ * WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
+ * General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with ALMOS-kernel; if not, write to the Free Software Foundation,
+ * Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA
+ */
+
+#ifndef _SYSFS_PRIVATE_H_
+#define _SYSFS_PRIVATE_H_
+
+#include <vfs.h>
+#include <sysfs.h>
+
+struct metafs_s;
+
+struct sysfs_node_s
+{
+	struct metafs_s *node;
+};
+
+struct sysfs_file_s
+{
+	struct metafs_iter_s iter;
+	struct metafs_s *node;
+	sysfs_entry_t *entry;
+	uint_t current_index;
+	sysfs_request_t rq;
+};
+
+extern const struct vfs_inode_op_s sysfs_i_op;
+extern const struct vfs_file_op_s sysfs_f_op;
+
+#endif	/* _SYSFS_PRIVATE_ */
Index: trunk/kernel/fs/sysfs/sysfs.h
===================================================================
--- trunk/kernel/fs/sysfs/sysfs.h	(revision 1)
+++ trunk/kernel/fs/sysfs/sysfs.h	(revision 1)
@@ -0,0 +1,139 @@
+/*
+ * sysfs.h - sysfs interface 
+ *
+ * Authors   Ghassan Almaless (2008,2009,2010,2011,2012)
+ *           Mohamed Lamine Karaoui (2015)
+ *           Alain Greiner (2016)
+ *
+ * Copyright (c) 2011,2012 UPMC Sorbonne Universites
+ *
+ * This file is part of ALMOS-MKH.
+ *
+ * ALMOS-MKH is free software; you can redistribute it and/or modify it
+ * under the terms of the GNU General Public License as published by
+ * the Free Software Foundation; version 2.0 of the License.
+ *
+ * ALMOS-MKH is distributed in the hope that it will be useful, but
+ * WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
+ * General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with ALMOS-MKH; if not, write to the Free Software Foundation,
+ * Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA
+ */
+
+#ifndef _SYSFS_H_
+#define _SYSFS_H_
+
+#include <hal_types.h>
+#include <metafs.h>
+
+
+struct sysfs_op_s;
+struct sysfs_entry_s;
+struct sysfs_request_s;
+
+
+/*******************************************************************************************
+ * This structure TODO
+ ******************************************************************************************/
+
+typedef struct sysfs_context_s
+{
+	void * empty;
+}
+sysfs_context_t;
+
+/*******************************************************************************************
+ * Operations definition must be provided by underlying kernel subsystem.
+ ******************************************************************************************/
+
+typedef error_t (sysfs_request_func_t)( struct sysfs_entry_s   * entry, 
+                                        struct sysfs_request_s * rq, 
+                                        uint32_t               * offset );
+
+typedef struct sysfs_op_s
+{
+	sysfs_request_func_t *open;
+	sysfs_request_func_t *read;
+	sysfs_request_func_t *write;
+	sysfs_request_func_t *close;
+}
+sysfs_op_t;
+
+/*******************************************************************************************
+ * This structure TODO  
+ ******************************************************************************************/
+
+typedef struct sysfs_request_s
+{
+	void     * data;
+	uint32_t   count;
+	uint8_t    buffer[CONFIG_SYSFS_BUFFER_SIZE];
+}
+sysfs_request_t;
+
+/*******************************************************************************************
+ * This structure TODO  
+ ******************************************************************************************/
+
+typedef struct sysfs_entry_s
+{
+	sysfs_op_t   op;
+	metafs_t     node;
+}
+sysfs_entry_t;
+
+/*******************************************************************************************
+ *        Extern Variable : sysfs root node.
+ ******************************************************************************************/
+
+extern sysfs_entry_t       sysfs_root_entry;
+
+/*******************************************************************************************
+ * This function initializes the sysfs root.
+ ******************************************************************************************/
+static inline void sysfs_root_init()
+{
+    if( CONFIG_ROOTFS_IS_VFAT ) metafs_init( &sysfs_root_entry.node , "SYS" );
+    else                        metafs_init( &sysfs_root_entry.node , "sys" );
+}
+
+
+/*******************************************************************************************
+ * This function initializes a given sysfs entry.
+ ******************************************************************************************/
+static inline void sysfs_entry_init( sysfs_entry_t * entry,
+                                     sysfs_op_t    * op,
+                                     char          * name )
+{
+	metafs_init( &entry->node , name );
+
+	if(op == NULL) return;
+  
+	entry->op.open  = op->open;
+	entry->op.read  = op->read;
+	entry->op.write = op->write;
+	entry->op.close = op->close;
+}
+
+/*******************************************************************************************
+ * This function registers a given sysfs entry into it's parent list.
+ ******************************************************************************************/
+static inline void sysfs_entry_register( sysfs_entry_t * parent,
+                                         sysfs_entry_t * entry )
+{
+	metafs_register( &parent->node , &entry->node );
+}
+
+/*******************************************************************************************
+ * This function removes a given sysfs entry from it's parent list.
+ ******************************************************************************************/
+static inline void sysfs_entry_unregister( sysfs_entry_t * parent,
+                                           sysfs_entry_t * entry )
+{
+	metafs_unregister( &parent->node , &entry->node );
+}
+
+#endif	/* _SYSFS_H_ */
